//+------------------------------------------------------------------+
//|                                                  Para RSI SW.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Gray
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 DodgerBlue

#property indicator_width4 2

extern string SAR_inputs___________________ = "_______________________________";
extern double Step = 0.01;
extern double Maximum = 0.1;
extern string RSI_inputs___________________ = "_______________________________";
extern int RSI_Period = 13;//5
extern int RSI_Price  = 0;

double sarstart_buffer[];
double sarup_buffer[];
double sardown_buffer[];
double rsi[];
int gi_124;
int gi_128;
double gd_132;
double gd_140;
double gd_148;
double gd_156;
double gd_164;
bool gi_172 = TRUE;

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0, sarstart_buffer);
   
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 159);
   SetIndexBuffer(1, sarup_buffer);
   
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 159);
   SetIndexBuffer(2, sardown_buffer);
   
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, rsi);
   return (0);
}

void SaveLastReverse(int ai_0, int ai_4, double ad_8, double ad_16, double ad_24, double ad_32, double ad_40) {
   gi_124 = ai_0;
   gi_128 = ai_4;
   gd_132 = ad_8;
   gd_148 = ad_16;
   gd_140 = ad_24;
   gd_156 = ad_32;
   gd_164 = ad_40;
}

int start() {
   bool li_0;
   double ld_4;
   double l_irsi_12;
   double l_irsi_20;
   double l_irsi_28;
   double ld_36;
   double l_irsi_44;
   double l_irsi_60;
   double l_irsi_52;
   int counted_bars = IndicatorCounted();
   if (Bars < 3) return (0);
   int shift = Bars - 2;
   if (counted_bars == 0 || gi_172) {
      gi_172 = FALSE;
      li_0 = TRUE;
      ld_4 = Step;
      l_irsi_12 = -10000000.0;
      l_irsi_20 = 10000000.0;
      while (shift > 0) {
         gi_124 = shift;
         l_irsi_44 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
         if (l_irsi_20 > l_irsi_44) l_irsi_52 = l_irsi_44;
         l_irsi_52 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
         if (l_irsi_12 < l_irsi_52) l_irsi_20 = l_irsi_52;
         if (l_irsi_52 > iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1) && l_irsi_44 > iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1)) break;
         if (l_irsi_52 < iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1) && l_irsi_44 < iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1)) {
            li_0 = FALSE;
            break;
         }
         shift--;
      }
      for (int li_76 = shift; li_76 < Bars; li_76++) sarstart_buffer[li_76] = 0.0;
      if (li_0) {
         sarstart_buffer[shift] = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1);
         l_irsi_12 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
      } else {
         sarstart_buffer[shift] = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1);
         l_irsi_28 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
      }
      shift--;
   } else {
      shift = gi_124;
      ld_4 = gd_132;
      li_0 = gi_128;
      l_irsi_12 = gd_140;
      l_irsi_20 = gd_148;
      l_irsi_28 = gd_156;
      ld_36 = gd_164;
   }
   while (shift >= 0) {
      rsi[shift] = (iRSI(NULL, 0, RSI_Period,RSI_Price,shift)+2.0*iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1)+iRSI(NULL, 0, RSI_Period,RSI_Price,shift+2))/4; 
      l_irsi_44 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
      l_irsi_52 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift);
      if (li_0 && l_irsi_44 < sarstart_buffer[shift + 1]) {
         SaveLastReverse(shift, 1, ld_4, l_irsi_44, l_irsi_12, l_irsi_28, ld_36);
         ld_4 = Step;
         li_0 = FALSE;
         l_irsi_28 = l_irsi_44;
         l_irsi_20 = l_irsi_44;
         sarstart_buffer[shift] = l_irsi_12;
         shift--;
         continue;
      }
      if (!li_0 && l_irsi_52 > sarstart_buffer[shift + 1]) {
         SaveLastReverse(shift, 0, ld_4, l_irsi_20, l_irsi_52, l_irsi_28, ld_36);
         ld_4 = Step;
         li_0 = TRUE;
         l_irsi_28 = l_irsi_52;
         l_irsi_12 = l_irsi_52;
         sarstart_buffer[shift] = l_irsi_20;
         shift--;
         continue;
      }
      l_irsi_60 = sarstart_buffer[shift + 1];
      ld_36 = l_irsi_60 + ld_4 * (l_irsi_28 - l_irsi_60);
      if (li_0) {
         if (l_irsi_28 < l_irsi_52 && ld_4 + Step <= Maximum) ld_4 += Step;
         if (l_irsi_52 < iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1) && shift == Bars - 2) ld_36 = sarstart_buffer[shift + 1];
         l_irsi_60 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1);
         if (ld_36 > l_irsi_60) ld_36 = l_irsi_60;
         l_irsi_60 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1);
         if (ld_36 > l_irsi_60) ld_36 = l_irsi_60;
         if (ld_36 > l_irsi_44) {
            SaveLastReverse(shift, 1, ld_4, l_irsi_44, l_irsi_12, l_irsi_28, ld_36);
            ld_4 = Step;
            li_0 = FALSE;
            l_irsi_28 = l_irsi_44;
            l_irsi_20 = l_irsi_44;
            sarstart_buffer[shift] = l_irsi_12;
            shift--;
            continue;
         }
         if (l_irsi_28 < l_irsi_52) {
            l_irsi_12 = l_irsi_52;
            l_irsi_28 = l_irsi_52;
         }
      } else {
         if (l_irsi_28 > l_irsi_44 && ld_4 + Step <= Maximum) ld_4 += Step;
         if (l_irsi_44 < iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1) && shift == Bars - 2) ld_36 = sarstart_buffer[shift + 1];
         l_irsi_60 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+1);
         if (ld_36 < l_irsi_60) ld_36 = l_irsi_60;
         l_irsi_60 = iRSI(NULL, 0, RSI_Period,RSI_Price,shift+2);
         if (ld_36 < l_irsi_60) ld_36 = l_irsi_60;
         if (ld_36 < l_irsi_52) {
            SaveLastReverse(shift, 0, ld_4, l_irsi_20, l_irsi_52, l_irsi_28, ld_36);
            ld_4 = Step;
            li_0 = TRUE;
            l_irsi_28 = l_irsi_52;
            l_irsi_12 = l_irsi_52;
            sarstart_buffer[shift] = l_irsi_20;
            shift--;
            continue;
         }
         if (l_irsi_28 > l_irsi_44) {
            l_irsi_20 = l_irsi_44;
            l_irsi_28 = l_irsi_44;
         }
      }
      sarstart_buffer[shift] = ld_36;
      
      if(ld_36 <= l_irsi_52){sarup_buffer[shift]=sarstart_buffer[shift];}
      else  if (ld_36 >= l_irsi_44) {sardown_buffer[shift]=sarstart_buffer[shift];}
      
      shift--;
   }
   return (0);
}